# uTu WebSDK

This is the uTu web-sdk. This package is used to track users within the browser environment so that uTu can identify users of messaging platforms in the web context. You can capture and update user detail as well as track events all from within the web interface.

# Getting Started
When your page load you need to init the uTu web-sdk.  This will generate an Id for the user and discover interesting information about them
such as location, ip, headers, etc.
```js
utu.init("apikey")
```
Another benefit of using the uTu web-sdk is that it enables you to track your users across domains without interruption.  Moving from your jobs.mysite.com to mysite.com?  No problem, uTu will recognize the user for you.

# Track
If you'd like to track new events about a given user of your site you can do so with the `track` function.
```js
utu.track("name", { foo: 'bar' })
```
The "name" given to track will show up as the "event" within the uTu console.  General advice on naming here is to NOT make names too long or detailed - intention is for this to be summary.  

The second param of track is optional but can help add additional context to a users action that you are Tracking
for instance maybe the event is `added item to cart` and you'd like to track `{ itemId: 10231 }` so you can create
a report in uTu for the most added items

# Identity
Your website might have new information about a user than your bot does, if you'd like to add this information to the users profile in uTu
you can do so with the `identity` function.
```js
utu.identity({
  firstName: "john",
  lastName: "doe",
  email: "john@doe.com",
  custom: {
    lastAddedItem: 10231,
    internalUserId: 10342131,
  },
})
```
uTu has a few 1st class fields that are used in special ways within uTu.  These are all optional.  The special fields are as follows:
### Special Fields
- firstName
- lastName
- name        // name will be parsed and split into its corresponding pieces by uTu. i.e. First, Last, Sirname, Suffix, etc. we have this just in case you don't have your users separating the fields in your system.
- email
- phone
- avatar  // url to an image of the user
